precision mediump float;

uniform vec3 uSunOrigin;
uniform sampler2D uTexture;

varying vec2 vTexcoords;
varying vec3 vWorldNormal;
varying vec3 vWorldPosition;

void main(void) {

    // calculate lambert
    vec3 nLightDir = normalize(uSunOrigin - vWorldPosition);
    vec3 nWorldNorm = normalize(vWorldNormal);

    float lambert = max(dot(nLightDir, nWorldNorm), 0.);


    // get diffuse contribution
    vec4 texture = texture2D(uTexture, vTexcoords);
    vec3 diffuse = texture.rgb * lambert;

    gl_FragColor = vec4(diffuse, texture.a);
}
